import { BaseController } from '@/api/BaseController';
import { RequestOption } from '@/common/http/types';
import { ANY_OBJECT } from '@/types/generic';
import { TableData } from '@/common/types/table';
import { useUrlBuilder } from '@/common/hooks/useUrl';
import TourProjectGroupPurchaseBanner from '@/types/table/tourProjectGroupPurchaseBanner';
import { API_CONTEXT } from '../config';

const { buildGetUrl } = useUrlBuilder();

export interface TourProjectGroupPurchaseBannerData extends TourProjectGroupPurchaseBanner {
  __cascade_add_temp_id__?: string | number | undefined;
}

export default class TourProjectGroupPurchaseBannerController extends BaseController {
  static list(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post<TableData<TourProjectGroupPurchaseBannerData>>(API_CONTEXT + '/app/tourProjectGroupPurchaseBanner/list', params, httpOptions);
  }
  static view(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.get<TourProjectGroupPurchaseBannerData>(API_CONTEXT + '/app/tourProjectGroupPurchaseBanner/view', params, httpOptions);
  }
  static export(params: ANY_OBJECT, fileName: string) {
    return super.download(API_CONTEXT + '/app/tourProjectGroupPurchaseBanner/export', params, fileName);
  }
  static import(params: ANY_OBJECT) {
    return super.upload(API_CONTEXT + '/app/tourProjectGroupPurchaseBanner/import', params);
  }
  static printUrl(params: ANY_OBJECT) {
    return buildGetUrl(API_CONTEXT + '/app/tourProjectGroupPurchaseBanner/print', params);
  }
  static add(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourProjectGroupPurchaseBanner/add', params, httpOptions);
  }
  static update(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourProjectGroupPurchaseBanner/update', params, httpOptions);
  }
  static delete(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourProjectGroupPurchaseBanner/delete', params, httpOptions);
  }
  static deleteBatch(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourProjectGroupPurchaseBanner/deleteBatch', params, httpOptions);
  }
}
